#!/bin/bash
#------------------------------------------------------------------------------
# /var/install/bin/inadyn-logmessages.sh
#
# Last Update: 2021-03-29 se, sebastian(dot)ertz(at)tk(minus)ertz(dot)de
#
# Copyright (c) 2001-2023 the eisfair team, team(at)eisfair(dot)org
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#------------------------------------------------------------------------------

#==============================================================================
# Main
#==============================================================================
Main(){
	local -a argv=("$0" "$@")
	local i argc="${#argv[@]}"
	for((i=0;i<${#argv[@]};i++)); do
		argv[i]="${argv[i]#${argv[i]%%[!\"]*}}"
		argv[i]="${argv[i]%${argv[i]##*[!\"]}}"
	done

	if [[ $argc -gt 6 && ${argv[2]} == "inadyn" && ${argv[3]} && ${argv[4]} &&  ${argv[6]} ]]; then
		case "${argv[1]}" in
			pre)
				local filename
				case "${argv[3]}" in
					menu)
						{
							printf "<!-- %s -->\n" "${argv[6]}"
							printf "<!-- Creation: %(%Y-%m-%d %H:%M)T by /var/install/bin/inadyn-logmessages.sh -->\n" -1
							printf "<title>In-a-Dyn %s</title>\n" "${argv[6]}"
							printf "<package>inadyn</package>\n"
							for filename in $(find /var/log -name "messages" -or -name "messages.*" 2>/dev/null|sort -V); do
								printf "<doc pre=\"/var/install/bin/inadyn-logmessages.sh\" post=\"/var/install/bin/inadyn-logmessages.sh\" tail=\"yes\" file=\"/var/install/menu/inadyn.logmessages.%s\">%s</doc>\n" "$RANDOM$RANDOM" "$(basename "$filename")"
							done
						} > "${argv[4]}"
						;;

					doc)
						case "${argv[6]}" in
							*.bz2) bzgrep -E "[[:blank:]]inadyn[[0-9]+]:[[:blank:]]" "/var/log/${argv[6]}" > "${argv[4]}" ;;
							*.xz)  xzgrep -E "[[:blank:]]inadyn[[0-9]+]:[[:blank:]]" "/var/log/${argv[6]}" > "${argv[4]}" ;;
							*)     grep   -E "[[:blank:]]inadyn[[0-9]+]:[[:blank:]]" "/var/log/${argv[6]}" > "${argv[4]}" ;;
						esac
						[[ -s "${argv[4]}" ]] || printf "Info: Nothing has been logged until now.\n" > "${argv[4]}"
						;;
				esac
				[[ -f "${argv[4]}" ]] && chmod 0640 "${argv[4]}" && chown root:root "${argv[4]}"
			;;

			post) rm -f "${argv[4]}" ;;
		esac
	fi
}
Main "$@"


#==============================================================================
# End
#==============================================================================
exit 0
